Files
apfstests/tests/xfs/012
T
Darrick J. Wong a860a167d8 common: kill _supported_os
fstests only supports Linux, so get rid of this unnecessary predicate.

Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
Reviewed-by: Christoph Hellwig <hch@lst.de>
Signed-off-by: Eryu Guan <guaneryu@gmail.com>
2020-09-21 01:16:50 +08:00

104 lines
2.6 KiB
Bash
Executable File

#! /bin/bash
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2000-2001 Silicon Graphics, Inc. All Rights Reserved.
#
# FS QA Test No. 012
#
# holes
#
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=0 # success is the default!
trap "_cleanup; exit \$status" 0 1 2 3 15
_cleanup()
{
cd /
rm -f $tmp.*
rm -rf $TEST_DIR/holes.$$.*
}
_filesize()
{
ls -l $1 | $AWK_PROG '{print " filesize = " $5}'
}
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
_do_test()
{
_n="$1"
_param="$2"
_count="$3"
failed=0
out=$TEST_DIR/holes.$$.$_n
echo ""
echo "holes.$_n : $_param"
echo "-----------------------------------------------"
if ! $here/src/holes $_param $out >$tmp.out
then
echo " holes returned $? - see $seqres.full"
failed=1
status=1
fi
if [ $failed -eq 0 ]
then
# quick check - how many holes did we get?
count=`xfs_bmap $out | egrep -c ': hole'`
echo " $count hole(s) detected"
# and how big was the file?
_filesize $out
if [ $count -ne $_count ]
then
echo " unexpected number of holes - see $seqres.full"
status=1
failed=1
fi
fi
if [ $failed -eq 1 ]
then
echo "--------------------------------------" >>$seqres.full
echo "$_n - output from holes:" >>$seqres.full
echo "--------------------------------------" >>$seqres.full
cat $tmp.out >>$seqres.full
echo "--------------------------------------" >>$seqres.full
echo "$_n - output from bmap:" >>$seqres.full
echo "--------------------------------------" >>$seqres.full
xfs_bmap -vvv $out >>$seqres.full
echo "--------------------------------------" >>$seqres.full
echo "$_n - output from ls -li:" >>$seqres.full
echo "--------------------------------------" >>$seqres.full
ls -li $out >>$seqres.full
status=1
fi
}
# real QA test starts here
_supported_fs xfs
_require_test
rm -f $seqres.full
# small & fairly dense
_do_test 1 "-l 40960000 -b 40960 -i 10 -c 1" 100
# big & sparse
_do_test 2 "-l 409600000 -b 40960 -i 1000 -c 1" 10
# no holes, but a very nasty way to write a file (lots of extents)
_do_test 3 "-l 40960000 -b 40960 -i 10 -c 10" 0
exit